/* base64.cc 23/10/1997 17.15.58 */
int base64_decode (char *dst, int sizedst, const char *bufcoded);
/* buttongif.cc 12/12/1999 22.10.48 */
void button_text2png (const char *str, FILE *fout);
/* buttons.cc 15/04/2000 00.09.36 */
bool dialog_usinglynx (void);
void dialog_setuselynx (bool uselynx);
void dialog_mayuselynx (bool mayuselynx);
/* checkbox.cc 13/07/2000 16.02.50 */
/* checklist1.cc 26/09/1996 13.54.12 */
int dialog_checklist_p (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int list_height,
	 int item_no,
	 char **items);
/* checklist.cc 30/09/1996 10.50.30 */
int dialog_checklist (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int ,
	 int item_no,
	 char **items,
	 char *status);
/* chkmval.cc 26/05/2000 16.31.00 */
/* cmdsock.cc 07/04/2000 21.01.46 */
void logevent (const char *fmt, ...);
void logdebug (int level, const char *fmt, ...);
int cmdsock_connect (const char *servname, int port, int nbretry);
int cmdsock_connect (const char *servname,
	 const char *portname,
	 int nbretry);
int cmdsock_wait (int nbfds, int fds[], int ready[], long timeout);
int cmdsock_wait (int fd, long timeout);
/* def.cc 30/03/1996 00.21.00 */
/* diaetc.cc 13/07/2000 16.02.58 */
EXPORT void dialog_end (void);
bool dialog_isinit (void);
bool dialog_uiok (void);
void init_dialog (void);
void diaetc_forcemono (void);
void color_setup (void);
void attr_clear (WINDOW *win, int height, int width, chtype attr);
void print_button (WINDOW *win,
	 const char *label,
	 int y,
	 int x,
	 int selected);
void draw_box (WINDOW *win,
	 int y,
	 int x,
	 int height,
	 int width,
	 chtype box,
	 chtype border_light,
	 chtype border_shadow);
void draw_shadow (WINDOW *, int , int , int , int);
EXPORT int dialog_parseuioptions (int argc, char *argv[]);
void diaetc_drawinput (WINDOW *dialog,
	 int x,
	 int y,
	 int width,
	 const char *s);
/* diagui.cc 29/06/2000 13.38.40 */
void diagui_setmode (DIAGUI_MODE mode);
void diagui_sethandle (int handlein, int handleout, const char *lines);
int diagui_init (void);
EXPORT const char *diagui_getlast_actionid (void);
void diagui_resetmsg (void);
EXPORT const char *diagui_quote (const char *s, char tmp[1000]);
void diagui_send (const char *ctl, ...);
EXPORT void diagui_sendcmd (int cmd, const char *ctl, ...);
EXPORT void diagui_flush (void);
void diagui_send_Label (const char *str);
EXPORT int diagui_sendxpm (const char *name, char *name_sent);
EXPORT void diagui_setdefaultctx (const char *s);
EXPORT int diagui_sync (const char *dianame,
	 SSTRING&path,
	 SSTRING&action,
	 SSTRING&menubar);
EXPORT int diagui_sync (POPENFD&po, int timeout);
void diagui_sethtmlhelp (void);
void diagui_sendhtmlhelp (const char *path);
void diagui_showhelp (const char *relpath);
EXPORT void diagui_showhelp (HELP_FILE&helpfile);
EXPORT const char *diagui_getval (char prefix, int nof);
EXPORT const char *diagui_getval (const char *diapath,
	 char prefix,
	 int nof);
EXPORT const char *diagui_getval (const char *diapath,
	 char prefix,
	 const char *str);
EXPORT const char *diagui_getval (char prefix, const char *str);
EXPORT int diagui_getvals (const char *diapath,
	 char prefix,
	 int nof,
	 SSTRINGS&tb);
EXPORT int diagui_getvals (char prefix, int nof, SSTRINGS&tb);
EXPORT void dialog_sendmessage (const char *msg);
EXPORT void dialog_sendmessage (PRIVATE_MESSAGE&msg);
EXPORT const char *dialog_getmessage (void);
EXPORT PRIVATE_MESSAGE *dialog_getprivmessage (void);
EXPORT bool dialog_testmessage (const char *msg);
EXPORT bool dialog_testmessage (PRIVATE_MESSAGE&msg);
EXPORT bool dialog_testtimer (const char *id);
EXPORT bool dialog_testtimer (PRIVATE_MESSAGE&msg);
EXPORT void dialog_settimer (const char *id, int seconds, bool rearm);
EXPORT void dialog_settimer (PRIVATE_MESSAGE&msg,
	 int seconds,
	 bool rearm);
EXPORT void dialog_deltimer (const char *id);
EXPORT void dialog_deltimer (PRIVATE_MESSAGE&msg);
/* dialist.cc 27/06/2000 23.03.24 */
/* dialog.cc 22/06/2000 00.03.34 */
void dialog_required (void);
EXPORT void dialog_clear (void);
void dialog_clearinit (void);
EXPORT void dialog_consout (const char *ctl, ...);
/* _dict.cc 14/08/1996 16.09.34 */
/* fcombo.cc 07/05/2000 23.01.42 */
/* fcombom.cc 19/04/2000 13.18.24 */
/* field.cc 29/06/2000 20.29.54 */
bool field_editline (WINDOW *dialog,
	 bool password_mode,
	 int key,
	 int box_width,
	 int box_y,
	 int box_x,
	 int size,
	 int &input_x,
	 int &scroll,
	 char *instr);
/* fldnum.cc 01/05/2000 12.03.06 */
/* fstrhelp.cc 01/05/2000 12.01.02 */
/* ftitle.cc 04/07/2000 14.01.28 */
void ftitle_clist (int nof,
	 const char *tag,
	 const char *buf,
	 bool is_title,
	 const char *dianame,
	 bool setval);
/* html.cc 07/06/2000 23.52.26 */
EXPORT int html_gethandle (void);
EXPORT const char *html_getval (const char *key);
const char *html_getoldval (const char *key);
void html_stresc (char *dst, const char *src, int size);
void html_defvar (const char *type,
	 const char *name,
	 const char *value,
	 const char *opt);
void html_defselect (const char *name);
void html_defvar (const char *type,
	 const char *name,
	 int value,
	 const char *opt);
void html_defvarcur (const char *name, const char *value);
void html_defvarcur (const char *name, int value);
EXPORT int html_printf (const char *ctl, ...);
void html_flush (void);
void html_sethost (const char *_hostname, int _port);
void html_setaref (const char *key, const char *text);
void html_formatkey (char *key, const char *ctl, ...);
void html_sendintro (const char *content_type,
	 int length,
	 int expires,
	 bool nocache);
void html_setdone (void);
const char *html_getcutinfo (void);
void html_setcutinfo (const char *s);
void html_ivldurl (void);
void html_needpasswd (void);
const char *html_getbodyparm (void);
void html_setbodyparm (const char *parm);
void html_forgetdialog (DIALOG *);
void html_adddialog (DIALOG *);
void html_registerpath (const char *basepath);
int html_locatefile (const char *fname,
	 const char *extension,
	 char *path,
	 int maxlen);
void html_setpopup (void);
void html_resetpopup (void);
const char *http_getbody (void);
int html_get (int _debug,
	 HELP_FILE&intro,
	 int timeout,
	 char module_key[50],
	 int &remhandle);
int html_getourname (char *name);
/* inputbox.cc 10/01/1999 01.07.36 */
EXPORT MENU_STATUS dialog_inputbox (const char *title,
	 const char *intro,
	 HELP_FILE&helpfile,
	 char inpstr[MAX_LEN+1]);
EXPORT MENU_STATUS dialog_inputbox (const char *title,
	 const char *intro,
	 HELP_FILE&helpfile,
	 SSTRING&inpstr);
EXPORT MENU_STATUS dialog_inputpass (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 char inpstr[MAX_LEN+1]);
/* internal.cc 25/08/1997 22.28.58 */
/* isocnv.cc 06/09/1997 05.00.14 */
/* kbd.cc 04/02/1998 14.29.16 */
void dialog_settimeout (int nbsec, MENU_STATUS retcod, bool rearm);
void dialog_starttimeout (void);
int dialog_getcurtimeout (void);
int dialog_wgetch (WINDOW *w, MENU_STATUS&timeout_button);
/* main.cc 26/09/1996 13.29.46 */
/* menubox.cc 04/07/2000 14.00.40 */
int menubox_getwidths (const char *pt, int tb[]);
void menubox_drawcols (const char *pt,
	 int tbcol[],
	 int max_width,
	 WINDOW *win,
	 const int hoffset,
	 int pos);
void menubox_setnogfx (void);
EXPORT void menubox_setcollect (void (*f)(const char *, const char *));
MENU_STATUS dialog_menu (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int options,
	 int item_no,
	 char **items,
	 int &sel);
/* modregister.cc 27/06/2000 14.35.02 */
/* msgbox.cc 13/12/1999 21.53.10 */
int dialog_msgbox (const char *title,
	 const char *prompt,
	 const char *icon);
/* multi.cc 03/07/2000 16.19.20 */
int dialog_textsize (const char *txt, int *width);
WINDOW *dialog_openwin (int height, int width);
void dialog_draw (WINDOW *dialog,
	 const char *title,
	 const char *internal_title,
	 const char *intro,
	 int height,
	 int width);
EXPORT DIALOG_MODE dialog_setmode (DIALOG_MODE mode);
void dialog_endlevel (void);
EXPORT void dialog_jumpto (const char *menupath);
EXPORT void dialog_jump2help (bool mode);
int multi_alloc_gui_id (void);
/* pass.cc 23/06/2000 11.55.04 */
void pass_required (void);
/* private_msg.cc 10/04/2000 22.17.06 */
/* radio.cc 01/05/2000 12.02.12 */
/* rc.cc 01/08/1996 00.00.04 */
void create_rc (char *filename);
int parse_rc (void);
/* samples.cc 04/07/2000 14.01.20 */
/* sheet.cc 21/06/2000 15.34.56 */
void sheet_required (void);
/* term.cc 08/05/2000 22.49.16 */
/* textarea.cc 24/06/2000 11.41.36 */
/* textbox.cc 18/04/2000 18.03.12 */
void textbox_expandtab (const char *src, char *dst, int maxsiz);
EXPORT MENU_STATUS dialog_textbox (const char *title, const char *file);
EXPORT MENU_STATUS dialog_textbox (const char *title,
	 const char *intro,
	 HELP_FILE&help,
	 const SSTRINGS&strs);
EXPORT MENU_STATUS dialog_textbox (const char *title,
	 const SSTRINGS&strs);
/* uithread.cc 23/06/2000 14.02.04 */
void uithread_sync (int (*editfct)());
void uithread_init (int nbtr);
void uithread_setmodal (void);
EXPORT int uithread (void (*fct)(void *), void *data);
EXPORT int uithread (void (*fct)());
/* varval.cc 17/09/1996 10.06.04 */
HTML_VARVAL *varval_get (int id);
/* yesno.cc 21/06/2000 21.40.22 */
EXPORT MENU_STATUS dialog_yesno (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 bool default_is_yes);
EXPORT MENU_STATUS dialog_yesno (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile);
